import React, {useState, useRef} from 'react';
import {
  StyleSheet,
  View,
  Dimensions,
  FlatList,
  Image,
  Text,
  TouchableOpacity,
  ScrollView,
} from 'react-native';
import Svg, {Line} from 'react-native-svg';
import {onConfigurations} from '../../common/helper';

const STT = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'K'];

export default (props) => {
  let refList1 = useRef(null);
  let refList2 = useRef(null);
  const {item, dispatch} = props;
  let {configurations} = item;
  configurations = JSON.parse(configurations);
  const {correct_answer} = configurations;

  const dataCol_1 = correct_answer.col_1.data;
  // dataCol_1.sort();

  const dataCol_2 = correct_answer.col_2.data;
  // dataCol_2.sort();

  const mergeData = [];
  const arrCol1 = [];
  const arrCol2 = [];
  dataCol_1.forEach((col_1, index) => {
    const data = {
      id: index,
      col_1: col_1,
      col_2: '',
      y1: 0,
      y2: 0,
      stt: '',
    };
    mergeData.push(data);
    const newCol1 = {
      value: col_1,
      selected: false,
    };
    arrCol1.push(newCol1);
    const newCol2 = {
      value: dataCol_2[index],
      selected: false,
    };
    arrCol2.push(newCol2);
  });

  arrCol2.sort((a, b) => {
    const x = a.value;
    const y = b.value;
    if (x < y) {
      return -1;
    }
    if (x > y) {
      return 1;
    }
    return 0;
  });
  arrCol2.map((item, index) => {
    item.stt = STT[index];
    return item;
  });

  const [merge, setMergeData] = useState({
    mergeData: mergeData,
    col1: arrCol1,
    col2: arrCol2,
  });

  const itemImage = ({item, index, onPress}) => {
    return (
      <TouchableOpacity
        style={[
          styles.viewText,
          {backgroundColor: item.selected ? '#ddd' : '#fff'},
        ]}
        activeOpacity={0.5}
        onPress={() => onPress(item, index)}>
        <Image
          style={styles.image}
          source={{uri: item.value}}
          resizeMode="contain"
        />
      </TouchableOpacity>
    );
  };

  const itemText = ({item, index, onPress}) => {
    return (
      <TouchableOpacity
        activeOpacity={0.5}
        onPress={() => {
          onPress(item, index);
        }}
        style={[
          styles.viewText,
          {backgroundColor: item.selected ? '#ddd' : '#fff'},
        ]}>
        <Text style={styles.text}>{item.value}</Text>
      </TouchableOpacity>
    );
  };

  const renderItem = (item, index, type) => {
    if (type === 1) {
      if (correct_answer.col_1.type === 'image') {
        return itemImage({item, index, onPress: onSelectedCol1});
      }
      if (correct_answer.col_1.type === 'text') {
        return itemText({item, index, onPress: onSelectedCol1});
      }
    } else {
      if (correct_answer.col_2.type === 'image') {
        return itemImage({item, index, onPress: onSelectedCol2});
      }
      if (correct_answer.col_2.type === 'text') {
        return itemText({item, index, onPress: onSelectedCol2});
      }
    }
  };

  const onSelectedCol1 = (item, index) => {
    const {mergeData, col1, col2} = merge;
    const totalCellLength1 = refList1._listRef._totalCellLength;
    const heightItem1 = totalCellLength1 / col1.length;

    const totalCellLength2 = refList2._listRef._totalCellLength;
    const heightItem2 = totalCellLength2 / col2.length;

    col1.map((i) => {
      if (i.value === item.value) {
        i.selected = i.selected ? false : true;
      } else {
        i.selected = false;
      }
      return i;
    });

    col2.map((i, ind) => {
      if (i.selected) {
        mergeData.map((mer) => {
          if (mer.id === index) {
            mer.col_2 = i.value;
            mer.y1 = (index + 1) * heightItem1 - heightItem1 / 2;
            mer.y2 = (ind + 1) * heightItem2 - heightItem2 / 2;
            mer.stt = i.stt;
          }
          return mer;
        });
        i.selected = false;
        item.selected = false;
        userAnswer(mergeData);
      }
    });
    setMergeData({...merge});
  };

  const onSelectedCol2 = (item, index) => {
    const {mergeData, col1, col2} = merge;
    const totalCellLength1 = refList1._listRef._totalCellLength;
    const heightItem1 = totalCellLength1 / col1.length;

    const totalCellLength2 = refList2._listRef._totalCellLength;
    const heightItem2 = totalCellLength2 / col2.length;

    col2.map((i) => {
      if (i.value === item.value) {
        i.selected = i.selected ? false : true;
      } else {
        i.selected = false;
      }
      return i;
    });

    col1.map((i, ind) => {
      if (i.selected) {
        mergeData.map((mer) => {
          if (mer.id === ind) {
            mer.col_2 = item.value;
            mer.y1 = (ind + 1) * heightItem1 - heightItem1 / 2;
            mer.y2 = (index + 1) * heightItem2 - heightItem2 / 2;
            mer.stt = item.stt;
          }
          return mer;
        });
        i.selected = false;
        item.selected = false;
        userAnswer(mergeData);
      }
    });
    setMergeData({...merge});
  };

  const userAnswer = (mergeData) => {
    // const original_order = [];
    const data1 = [];
    const data2 = [];
    const dataNotSelect = [];
    const correct_order = [];
    const arr_origin = [];

    arrCol2.forEach((item) => {
      const find = mergeData.find((f) => f.col_2 === item.value);
      if (!find) {
        dataNotSelect.push(item);
      }
    });

    mergeData.forEach((item, index) => {
      const col_2 = item.col_2;
      data1.push(item.col_1);
      data2.push(arrCol2[index].value);

      let origin;
      if (col_2.length > 0) {
        origin = {
          key: col_2,
          value: item.stt,
        };
      } else {
        origin = {
          key: dataNotSelect[0].value,
          value: '',
        };
        dataNotSelect.splice(0, 1);
      }
      arr_origin.push(origin);
    });
    const original_order = {...arr_origin};

    dataCol_2.forEach((correct) => {
      arrCol2.forEach((origin) => {
        if (correct === origin.value) {
          correct_order.push(origin.stt);
        }
      });
    });

    const col_1 = {
      type: correct_answer.col_1.type,
      data: data1,
    };

    const col_2 = {
      type: correct_answer.col_2.type,
      data: data2,
    };

    const user_answer = {
      value: {
        col_1: col_1,
        col_2: col_2,
        original_order: original_order,
        correct_order: correct_order,
      },
    };
    // console.log(232, user_answer);
    onConfigurations(item, user_answer, dispatch);
  };

  return (
    <View style={[styles.configView]}>
      <View style={{width: '35%'}}>
        <FlatList
          ref={(ref) => (refList1 = ref)}
          data={merge.col1}
          renderItem={({item, index}) => renderItem(item, index, 1)}
          keyExtractor={(item, index) => index.toString()}
        />
      </View>
      {merge.mergeData.map((item, index) => {
        if (item.y1 > 0 && item.y2 > 0)
          return (
            <Svg
              style={{
                position: 'absolute',
                left: x1,
              }}
              key={index}>
              <Line
                x1={0}
                y1={item.y1}
                x2={x2 - x1}
                y2={item.y2}
                stroke="red"
                strokeWidth="1"
              />
            </Svg>
          );
      })}
      <View style={{width: '35%'}}>
        <FlatList
          ref={(ref) => (refList2 = ref)}
          data={merge.col2}
          renderItem={({item, index}) => renderItem(item, index, 2)}
          keyExtractor={(item, index) => index.toString()}
        />
      </View>
    </View>
  );
};

const width = Dimensions.get('screen').width * 0.9;

const x1 = Dimensions.get('screen').width * 0.32;
const x2 = Dimensions.get('screen').width * 0.58;

const styles = StyleSheet.create({
  configView: {
    flexDirection: 'row',
    width: width,
    alignItems: 'center',
    justifyContent: 'space-between',
  },
  image: {
    minHeight: 50,
    // marginVertical: 10,
  },
  viewText: {
    borderColor: 'gray',
    borderWidth: 1,
    borderRadius: 10,
    marginVertical: 10,
    minHeight: 60,
    justifyContent: 'center',
  },
  text: {
    fontSize: 14,
    color: 'black',
    alignContent: 'center',
    marginHorizontal: 10,
  },
});
