import React from 'react';
import {
  StyleSheet,
  Text,
  TouchableOpacity,
  View,
  Image,
  Dimensions,
} from 'react-native';
export default (props) => {
  const {check, onPress, type, data} = props;

  return (
    <TouchableOpacity
      onPress={onPress}
      style={[
        styles.configView,
        {
          backgroundColor: check ? '#01c660' : 'transparent',
        },
      ]}>
      {data.type === 'text' && (
        <Text
          style={{
            color: check ? '#fff' : '#000',
            fontSize: 16,
            fontWeight: 'bold',
          }}>
          {data.value}
        </Text>
      )}
      {data.type === 'image' && (
        <Image
          style={styles.image}
          source={{uri: data.value}}
          resizeMode="contain"
        />
      )}
    </TouchableOpacity>
  );
};

const width = Dimensions.get('screen').width * 0.8;

const styles = StyleSheet.create({
  configView: {
    width: width,
    minHeight: 45,
    borderColor: 'gray',
    borderWidth: 1,
    borderRadius: 10,
    marginVertical: '2%',
    padding: 10,
  },
  image: {
    width: 100,
  },
});
