import React from 'react';
import {StyleSheet, View, TextInput, Dimensions} from 'react-native';
import {onConfigurations} from '../../common/helper';

export default (props) => {
  const {item, dispatch} = props;
  //   console.log('writing', item);
  return (
    <View style={[styles.configView]}>
      <TextInput
        autoFocus={true}
        style={styles.textInput}
        multiline={true}
        underlineColorAndroid="transparent"
        onChangeText={(text) => onConfigurations(item, text, dispatch)}
        autoCapitalize="none"
        returnKeyType="done"
      />
    </View>
  );
};

const width = Dimensions.get('screen').width * 0.8;
const styles = StyleSheet.create({
  configView: {
    width: width,
    minHeight: 50,
    borderColor: 'gray',
    borderWidth: 1,
    borderRadius: 10,
    padding: 10,
  },
  textInput: {
    color: 'black',
    fontSize: 16,
    textAlign: 'center',
  },
});
