import 'react-native-gesture-handler';

import * as React from 'react';
import {NavigationContainer} from '@react-navigation/native';
import {createStackNavigator} from '@react-navigation/stack';
import Icon from 'react-native-vector-icons/FontAwesome';
import Feather from 'react-native-vector-icons/Feather';

//screen
import HomeScreen from '../pages/home';
import StartScreen from '../pages/start';
Icon.loadFont();
Feather.loadFont();
const Stack = createStackNavigator();

const Router = (props) => {
  return (
    <NavigationContainer independent={true}>
      <Stack.Navigator initialRouteName="Home">
        <Stack.Screen
          name="Home"
          component={HomeScreen}
          options={{headerShown: false}}
          initialParams={props?.params}
        />
        <Stack.Screen
          name="Start"
          component={StartScreen}
          options={{headerShown: false}}
          initialParams={props?.params}
        />
      </Stack.Navigator>
    </NavigationContainer>
  );
};

export default Router;
